﻿<cfcomponent>
	<cffunction name="getSiteFeedInt" access="public" output="false" returntype="query">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="id" type="string" required="no" default="0">
		<cfargument name="site_id" type="string" required="no" default="#session.current_site_id#">
            <cfquery datasource="#application.DB#" name="GetSiteFeedInt">
                SELECT #arguments.fields# FROM ice_site_feed_int  WHERE 0=0
<cfif isdefined("form.ice_status_id") AND form.ice_status_id IS NOT 0>AND ice_status_id=#form.ice_status_id#</cfif>
<cfif isdefined("form.ice_channel_id") AND form.ice_channel_id IS NOT 0>AND ice_channel_id=#form.ice_channel_id#</cfif>
<cfif isdefined("form.ice_user_id") AND form.ice_user_id IS NOT 0>AND ice_user_id=#form.ice_user_id#</cfif>
<cfif isdefined("form.ice_site_feed_int") AND form.ice_site_feed_int IS NOT ''>AND (ice_site_feed_int LIKE '%#form.ice_site_feed_int#%' OR description LIKE '%#form.ice_site_feed_int#%')</cfif>
<cfif isdefined("arguments.id") AND arguments.id IS NOT 0>AND id IN (#arguments.id#)</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.status_id") AND arguments.status_id IS NOT  0>AND ice_status_id = #arguments.status_id#</cfif>
ORDER BY ice_site_feed_int ASC
            </cfquery>
		<cfreturn GetSiteFeedInt>
	</cffunction>


	


	<cffunction name="countSiteFeedInt" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountSiteFeedInt">
                SELECT #arguments.fields# FROM ice_site_feed_int 
WHERE 0=0
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT 0>AND ice_status_id=#arguments.ice_status_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
            </cfquery>
<cfset countlanguage=CountSiteFeedInt.Recordcount>
		<cfreturn countlanguage>
	</cffunction>


	<cffunction name="addSiteFeedInt" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="user_id" type="string" required="no" default="0">

<cfset form.ice_site_id=#session.current_site_id#>
<cfset form.ice_user_id=#session.user_id#>
<cfset form.created=now()>

<cftry>

<cfif form.ice_channel_id IS NOT 0>
<cfquery name="GetChannelName" datasource="#application.db#">
SELECT ice_channel,folder FROM ice_channel WHERE id=#form.ice_channel_id#
</cfquery>
	<CFIF GetChannelName.recordcount IS 1 AND GetChannelName.folder IS NOT ''>

<cfset rss_code='
<cfprocessingdirective suppresswhitespace="yes">
<cfinvoke component="ice.#application.api_folder#.page" method="getPage" ice_status_id="1" ice_channel_id="#form.ice_channel_id#" returnvariable="getPage">

<!--- Map Query --->
<cfset columnMapStruct = StructNew()>
<cfset columnMapStruct.publisheddate = "CREATED"> 
<cfset columnMapStruct.content = "SUMMARY"> 
<cfset columnMapStruct.title = "ICE_PAGE"> 
<cfset columnMapStruct.rsslink = "ID">
<!--- Set the feed metadata. --->
<cfset meta.title = "#form.ice_site_feed_int#">
<cfset meta.link = "#application.ice_url#/sites/#session.current_site_folder#/rss/#GetChannelName.folder#.cfm">
<cfset meta.description = "#form.description#"> 
<cfset meta.version = "rss_2.0">
<!--- Create Feed --->
<cffeed action = "create" query="##getPage##" properties="##meta##" columnMap = "##columnMapStruct##" xmlvar="rssXML">
<cfoutput>##xmlparse(rssXML)##</cfoutput>
</cfprocessingdirective>
'>
<CFFILE ACTION="write" OUTPUT="#rss_code#" ADDNEWLINE="No" FIXNEWLINE="Yes" File="#application.ice_path#\sites\#session.current_site_folder#\rss\#GetChannelName.folder#.cfm" charset="utf-8">

<cfset form.file='#GetChannelName.folder#.cfm'>
	<CFELSE>
<cfset form.file=''>
	</CFIF>

<cfinsert tablename="ice_site_feed_int" datasource="#application.db#" formfields="#arguments.fields#,ice_user_id,file,ice_site_id,created">
<cfelse>
<cfinsert tablename="ice_site_feed_int" datasource="#application.db#" formfields="#arguments.fields#,ice_user_id,ice_site_id,created">

</cfif>


<cfcatch type="any"><cfset addlanguage=0><cfreturn addlanguage></cfcatch>
</cftry>	
<cfset addlanguage=1>
		<cfreturn addlanguage>

	</cffunction>

	<cffunction name="updateSiteFeedInt" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">

<cftry>

<cfif form.ice_channel_id IS NOT 0>

<cfquery name="CheckChannel" datasource="#application.db#">
SELECT ice_channel_id,file FROM ice_site_feed_int WHERE id=#form.id#
</cfquery>

<CFIF CheckChannel.ice_channel_id IS NOT form.ice_channel_id>

<cfquery name="GetChannelName" datasource="#application.db#">
SELECT ice_channel,folder FROM ice_channel WHERE id=#form.ice_channel_id#
</cfquery>

	<CFIF GetChannelName.recordcount IS 1 AND GetChannelName.folder IS NOT ''>
<cfset rss_code='
<cfprocessingdirective suppresswhitespace="yes">
<cfinvoke component="ice.#application.api_folder#.page" method="getPage" ice_status_id="1"  ice_channel_id="#form.ice_channel_id#" returnvariable="getPage">

<!--- Map Query --->
<cfset columnMapStruct = StructNew()>
<cfset columnMapStruct.publisheddate = "CREATED"> 
<cfset columnMapStruct.content = "SUMMARY"> 
<cfset columnMapStruct.title = "ICE_PAGE"> 
<cfset columnMapStruct.rsslink = "ID">
<!--- Set the feed metadata. --->
<cfset meta.title = "#form.ice_site_feed_int#">
<cfset meta.link = "#application.ice_url#/sites/#session.current_site_folder#/rss/#GetChannelName.folder#.cfm">
<cfset meta.description = "#form.description#"> 
<cfset meta.version = "rss_2.0">
<!--- Create Feed --->
<cffeed action = "create" query="##getPage##" properties="##meta##" columnMap = "##columnMapStruct##" xmlvar="rssXML">
<cfoutput>##xmlparse(rssXML)##</cfoutput>
</cfprocessingdirective>
'>

<CFFILE ACTION="write" OUTPUT="#rss_code#" ADDNEWLINE="No"  FIXNEWLINE="Yes" File="#application.ice_path#\sites\#session.current_site_folder#\rss\#GetChannelName.folder#.cfm" charset="utf-8">
<cfif checkchannel.file IS NOT ''><cffile action="delete" File="#application.ice_path#\sites\#session.current_site_folder#\rss\#CheckChannel.file#"></cfif>

<cfset form.file='#GetChannelName.folder#.cfm'>
	<CFELSE>
<cfset form.file=''>
	</CFIF>
<cfupdate tablename="ice_site_feed_int" datasource="#application.db#" formfields="id,#arguments.fields#,file">
<CFELSE>
<cfupdate tablename="ice_site_feed_int" datasource="#application.db#" formfields="id,#arguments.fields#">
</CFIF>


<cfelse>
<cfupdate tablename="ice_site_feed_int" datasource="#application.db#" formfields="id,#arguments.fields#">
</cfif>
<cfcatch type="any"><cfset updatelanguage=0><cfreturn updatelanguage></cfcatch>
</cftry>	

<cfset updatelanguage=1>
		<cfreturn updatelanguage>

	</cffunction>

	<cffunction name="deleteSiteFeedInt" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="id" type="string" required="no" default="0">
<CFIF Isdefined("url.confirm") AND url.confirm IS 'yes'>
<cftry>


<cfquery name="DeleteSiteFeedInt" datasource="#application.db#">
DELETE FROM ice_site_feed_int WHERE id=#arguments.id#
</cfquery>
<cfcatch type="any"><cfset deletelanguage=0><cfreturn deletelanguage></cfcatch>
</cftry>	
<cfset deletelanguage=1>
<cfelse>
<cfset deletelanguage=0><cfreturn deletelanguage>
</cfif>
		<cfreturn deletelanguage>
	</cffunction>
</cfcomponent>