<cfcomponent>
	<cffunction name="getModules" access="public" output="false" returntype="query">
            <cfquery datasource="#application.DB#" name="GetModules">
<cfif isdefined("session.language") AND len(session.language) IS 2>
                SELECT id,ice_module, #session.language# as description, color,installed,icon,icon_off,version FROM ice_module
<cfelse>
                SELECT * FROM ice_module 
</cfif>	
ORDER BY Rank ASC
            </cfquery>
<cfif isdefined("arguments.installed") AND arguments.installed IS NOT 0>AND installed=#arguments.installed#</cfif>
		<cfreturn GetModules>
	</cffunction>


	<cffunction name="getInstalledModules" access="public" output="false" returntype="query">
		<cfargument name="module_id" type="string" required="no" default="0">
		<cfargument name="installed" type="numeric" required="no" default="0">
            <cfquery datasource="#application.DB#" name="GetInstalledModules">
                	SELECT * FROM ice_module WHERE 0=0
	<cfif arguments.installed IS NOT 0>AND installed=#arguments.installed#</cfif>

<cfif arguments.module_id IS NOT 0>AND id=<cfqueryparam value="#arguments.module_id#" CFSQLType= "CF_SQL_INTEGER"></cfif>
            </cfquery>
		<cfreturn GetInstalledModules>
	</cffunction>

	<cffunction name="countModule" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountModule">
                SELECT #arguments.fields# FROM ice_module 
WHERE 0=0
<cfif isdefined("arguments.installed")>AND installed=#arguments.installed#</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
            </cfquery>
<cfset countmodule=CountModule.Recordcount>
		<cfreturn CountModule>
	</cffunction>

</cfcomponent>