﻿<cfcomponent>
	<cffunction name="getSiteFeedExt" access="public" output="false" returntype="query">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="id" type="string" required="no" default="0">
		<cfargument name="site_id" type="string" required="no" default="#session.current_site_id#">
            <cfquery datasource="#application.DB#" name="GetSiteFeedExt">
                SELECT #arguments.fields# FROM ice_site_feed_ext  WHERE 0=0
<cfif isdefined("form.ice_status_id") AND form.ice_status_id IS NOT 0>AND ice_status_id=#form.ice_status_id#</cfif>
<cfif isdefined("form.ice_channel_id") AND form.ice_channel_id IS NOT 0>AND ice_channel_id=#form.ice_channel_id#</cfif>
<cfif isdefined("form.ice_user_id") AND form.ice_user_id IS NOT 0>AND ice_user_id=#form.ice_user_id#</cfif>

<cfif isdefined("form.ice_site_feed_ext") AND form.ice_site_feed_ext IS NOT ''>AND (ice_site_feed_ext LIKE '%#form.ice_site_feed_ext#%' OR description LIKE '%#form.ice_site_feed_ext#%')</cfif>
<cfif isdefined("arguments.id") AND arguments.id IS NOT 0>AND id IN (#arguments.id#)</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.status_id") AND arguments.status_id IS NOT  0>AND ice_status_id = #arguments.status_id#</cfif>
ORDER BY ice_site_feed_ext ASC
            </cfquery>
		<cfreturn GetSiteFeedExt>
	</cffunction>



	<cffunction name="countSiteFeedExt" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="id">
            <cfquery datasource="#application.DB#" name="CountSiteFeedExt">
                SELECT #arguments.fields# FROM ice_site_feed_ext 
WHERE 0=0
<cfif isdefined("arguments.ice_status_id") AND arguments.ice_status_id IS NOT 0>AND ice_status_id=#arguments.ice_status_id#</cfif>
<cfif isdefined("arguments.site_id") AND arguments.site_id IS NOT  0>AND ice_site_id IN (#arguments.site_id#)</cfif>
<cfif isdefined("arguments.user_id") AND arguments.user_id IS NOT 0>AND ice_user_id=#arguments.user_id#</cfif>
            </cfquery>
<cfset countlanguage=CountSiteFeedExt.Recordcount>
		<cfreturn countlanguage>
	</cffunction>


	<cffunction name="addSiteFeedExt" access="public" output="false" returntype="numeric">
		<cfargument name="fields" type="string" required="no" default="*">
		<cfargument name="user_id" type="string" required="no" default="0">
<cfset form.ice_site_id=#session.current_site_id#>
<cfset form.ice_user_id=#session.user_id#>
<cfset form.created=now()>

<cftry>
<cfinsert tablename="ice_site_feed_ext" datasource="#application.db#" formfields="#arguments.fields#,ice_user_id,ice_site_id,created">

<cfcatch type="any"><cfset addlanguage=0><cfreturn addlanguage></cfcatch>
</cftry>	
<cfset addlanguage=1>
		<cfreturn addlanguage>
	</cffunction>

	<cffunction name="updateSiteFeedExt" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="fields" type="string" required="no" default="*">

<cftry>

<cfupdate tablename="ice_site_feed_ext" datasource="#application.db#" formfields="id,#arguments.fields#">
<cfcatch type="any"><cfset updatelanguage=0><cfreturn updatelanguage></cfcatch>
</cftry>	

<cfset updatelanguage=1>
		<cfreturn updatelanguage>

	</cffunction>

	<cffunction name="deleteSiteFeedExt" access="public" output="false" returntype="numeric">
		<cfargument name="user_id" type="string" required="no" default="0">
		<cfargument name="id" type="string" required="no" default="0">
<CFIF Isdefined("url.confirm") AND url.confirm IS 'yes'>
<cftry>

<cfquery name="DeleteSiteFeedExt" datasource="#application.db#">
DELETE FROM ice_site_feed_ext WHERE id=#arguments.id#
</cfquery>
<cfcatch type="any"><cfset deletelanguage=0><cfreturn deletelanguage></cfcatch>
</cftry>	
<cfset deletelanguage=1>
<cfelse>
<cfset deletelanguage=0><cfreturn deletelanguage>
</cfif>
		<cfreturn deletelanguage>
	</cffunction>
</cfcomponent>